// VAXOL (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*6*80];
unsigned char temp[0x400*6*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) {
		fprintf(stderr, "fBXNC[WႤۂł.\n");
		return false;
	}
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fload(int _trk, int _C, int _H, int _R, int _N, int _adr, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, temp, _size+_offset)) {
		fprintf(stderr, "fBXNC[WႤۂł.\n");
		return false;
	}
	memcpy(&buff[_adr],&temp[_offset],_size);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	unsigned char id_a[] = "V2-MODE";
	unsigned char id_b[] = "B-DISK";

	char fname[11];
	int i;
	int N;
	int id=0;
	int musnum=0;

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		// Track 2ID̓ǂݍ
		id = disk.ReadID(0x02, buff, 4*6)/4;
		if (id==0) {
			fprintf(stderr, "Ή̃fBXN`ł.\n");
			return 1;
		}
		if (buff[3]==6 && id==1) {
			// IWi (N=6 x 1)
			disk.SetRecordRange(0x01,0x01);
			disk.ReadDATA1(0, 0, 0, 1, 1, temp, 0x100);
			if (!memcmp(&temp[0x22],id_a,7)) {
				printf("[Original] Disk A F܂.\n");
				fcut("DRIVER", 0x02, 0x02, 0x00, 0x01, 0x06, 0x0000, 0x1000);
				fcut("MUS00", 0x09, 0x09, 0x01, 0x01, 0x06, 0x0400, 0x0700);
				fcut("MUS01", 0x09, 0x09, 0x01, 0x01, 0x06, 0x0b00, 0x0700);
				fload(0x09, 0x09, 0x01, 0x01, 0x06, 0x0000, 0x1200, 0x0500);
				fload(0x0a, 0x05, 0x00, 0x01, 0x06, 0x0500, 0x0000, 0x2000);
				fsave("MUS02", buff, 0x0600);
				fcut("MUS03", 0x0a, 0x05, 0x00, 0x01, 0x06, 0x0100, 0x0800);
				fcut("MUS04", 0x0a, 0x05, 0x00, 0x01, 0x06, 0x0e00, 0x0800);
			}
			else if (!memcmp(&temp[0x23],id_b,6)) {
				printf("[Original] Disk B F܂.\n");
				fcut("MUS05", 0x08, 0x04, 0x00, 0x01, 0x06, 0x0500, 0x0100);
				fcut("MUS06", 0x08, 0x04, 0x00, 0x01, 0x06, 0x0600, 0x0e00);
				fload(0x08, 0x04, 0x00, 0x01, 0x06, 0x0000, 0x1400, 0x0300);
				fload(0x09, 0x04, 0x01, 0x01, 0x06, 0x0300, 0x0000, 0x2000);
				fsave("MUS07", buff, 0x0800);
			}
		}
		else if (buff[3]==3 && id==6) {
			// obNAbv (N=3 x5, N=2 x1)
			disk.SetRecordRange(0x01,0x05);
			disk.ReadDATA(0, 0, 0, 1, 1, temp, 0x100);

			if (!memcmp(&temp[0x22],id_a,7)) {
				printf("[Backup] Disk A F܂.\n");
				fcut("DRIVER", 0x02, 0x01, 0x00, 0x01, 0x03, 0x0000, 0x1000);

				fload(0x09, 0x04, 0x01, 0x02, 0x03, 0x0000, 0x0000, 0x1000);
				fload(0x09, 0x04, 0x01, 0x06, 0x02, 0x1000, 0x0000, 0x0200);
				fload(0x4e, 0x27, 0x00, 0x03, 0x03, 0x1200, 0x0100, 0x0100);
				fload(0x0a, 0x05, 0x00, 0x01, 0x03, 0x1300, 0x0000, 0x0100);
				fload(0x09, 0x04, 0x01, 0x05, 0x03, 0x1400, 0x0100, 0x0100);
				fload(0x0a, 0x05, 0x00, 0x01, 0x03, 0x1500, 0x0100, 0x1300);
				fload(0x0a, 0x05, 0x00, 0x06, 0x02, 0x2800, 0x0000, 0x0200);

				fsave("MUS00", &buff[0x0000], 0x700);
				fsave("MUS01", &buff[0x0700], 0x700);
				fsave("MUS02", &buff[0x0e00], 0x600);
				fsave("MUS03", &buff[0x1500], 0x800);
				fsave("MUS04", &buff[0x2200], 0x800);
			}
			else if (!memcmp(&temp[0x23],id_b,6)) {
				printf("[Backup] Disk B F܂.\n");
				fcut("MUS05", 0x08, 0x04, 0x00, 0x02, 0x03, 0x0100, 0x0100);
				fcut("MUS06", 0x08, 0x04, 0x00, 0x02, 0x03, 0x0200, 0x0e00);	// F000h`
				fload(0x08, 0x04, 0x00, 0x06, 0x02, 0x0000, 0x0000, 0x0200);	// 6ʂƓ
				fload(0x4e, 0x27, 0x00, 0x03, 0x03, 0x0200, 0x0000, 0x0100);
				fload(0x09, 0x04, 0x01, 0x01, 0x03, 0x0300, 0x0000, 0x0500);
				fsave("MUS07", &buff[0x0000], 0x800);
			}
		}
	}
	return 0;
}

